'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _values = require('babel-runtime/core-js/object/values');

var _values2 = _interopRequireDefault(_values);

exports.default = featureComponents;

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _lodash = require('lodash.defaults');

var _lodash2 = _interopRequireDefault(_lodash);

var _reactRedux = require('react-redux');

var _reselect = require('reselect');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function featureComponents(options) {
  var _defaults = (0, _lodash2.default)({}, options, {
    getFeatures: function getFeatures(state) {
      return state ? state.features : {};
    },
    sortFeatures: function sortFeatures(features) {
      return (0, _values2.default)(features);
    }
  }),
      getFeatures = _defaults.getFeatures,
      sortFeatures = _defaults.sortFeatures,
      getComponents = _defaults.getComponents;

  var mapStateToProps = (0, _reselect.createStructuredSelector)({
    features: (0, _reselect.createSelector)(getFeatures, sortFeatures)
  });

  function mergeProps(_ref2, dispatchProps, _ref) {
    var features = _ref2.features;
    var children = _ref.children,
        props = (0, _objectWithoutProperties3.default)(_ref, ['children']);

    var renderedComponents = [];
    features.forEach(function (feature, featureIndex) {
      var components = getComponents(feature);
      if (components == null) return;
      if (!Array.isArray(components)) components = [components];
      components.forEach(function (Comp, index) {
        var key = featureIndex + ':' + index;
        if (React.isValidElement(Comp)) renderedComponents.push(React.cloneElement(Comp, (0, _extends3.default)({}, props, { key: key })));else if (typeof Comp === 'function') renderedComponents.push(React.createElement(Comp, (0, _extends3.default)({}, props, { key: key })));
      });
    });
    return {
      children: children instanceof Function ? children(renderedComponents) : React.createElement(
        'div',
        null,
        renderedComponents
      )
    };
  }

  var FeatureComponents = function FeatureComponents(_ref3) {
    var children = _ref3.children;
    return children;
  };

  return (0, _reactRedux.connect)(mapStateToProps, null, mergeProps)(FeatureComponents);
}