'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

exports.default = featureLoader;

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _reactRedux = require('react-redux');

var _reduxFeatures = require('redux-features');

var _reselect = require('reselect');

var _lodash = require('lodash.defaults');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function featureLoader(options) {
  var _defaults = (0, _lodash2.default)({}, options, {
    getFeatures: function getFeatures(state) {
      return state ? state.features : undefined;
    },
    getFeatureStates: function getFeatureStates(state) {
      return state ? state.featureStates : undefined;
    }
  }),
      getFeatures = _defaults.getFeatures,
      getFeatureStates = _defaults.getFeatureStates,
      featureId = _defaults.featureId,
      render = _defaults.render;

  var mapStateToProps = (0, _reselect.createSelector)(getFeatures, getFeatureStates, function () {
    var features = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var featureStates = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    return {
      feature: features[featureId],
      featureState: featureStates[featureId]
    };
  });

  function mergeProps(_ref, _ref2, props) {
    var feature = _ref.feature,
        featureState = _ref.featureState;
    var dispatch = _ref2.dispatch;

    return {
      dispatch: dispatch,
      featureState: featureState,
      children: render ? render({ feature: feature, featureState: featureState, props: props }) : null
    };
  }

  var FeatureLoader = function (_React$Component) {
    (0, _inherits3.default)(FeatureLoader, _React$Component);

    function FeatureLoader() {
      (0, _classCallCheck3.default)(this, FeatureLoader);
      return (0, _possibleConstructorReturn3.default)(this, (FeatureLoader.__proto__ || (0, _getPrototypeOf2.default)(FeatureLoader)).apply(this, arguments));
    }

    (0, _createClass3.default)(FeatureLoader, [{
      key: 'componentWillMount',
      value: function componentWillMount() {
        var _props = this.props,
            featureState = _props.featureState,
            dispatch = _props.dispatch;

        if (featureState === 'NOT_LOADED') dispatch((0, _reduxFeatures.loadFeature)(featureId));
      }
    }, {
      key: 'render',
      value: function render() {
        return this.props.children;
      }
    }]);
    return FeatureLoader;
  }(React.Component);

  return (0, _reactRedux.connect)(mapStateToProps, null, mergeProps)(FeatureLoader);
}